\chapter{Discussion and Conclusion}
With this research, we have concluded that indexing is an obligation for most of the databases out there. With automatic indexers like Dexter, adding indexes to the database tables has become much easier. Nevertheless, Dexter is not the holy grail to creating the perfect database indexes; some indexes require to be created manually by personal judgment because one must predict the queries that are to be assumed in the future to generate the right indexes for the database tables.\\\\
Each index requires maintenance and every index that is added to a table, adds an overhead to the write operations to that table (INSERT, UPDATE or DELETE) and therefore, it is not helpful and efficient to create indexes for each column. Indexes also take up disk space, and the database tries to keep them in memory, which means that they enlarge and slow down database backups. Every index generated comes with a trade-off so one must be mindful before adding them unless they are entirely sure that they will be useful for the queries.\\\\
Dexter can be used in automated mode, to create all the indexes it proposes automatically, but that's rather not the right way to do it, it should rather be used as a tool of recommendations, to suggest the right indexes and then based on personal judgment decide whether the suggested indexes are efficient and necessary for the targeted database.\\\\
Unfortunately, the extension HypoPG which is obliged for Dexter to run is not supported on some hosted providers like Amazon RDS or Heroku. This means that we need to copy the database and run Dexter there to use the automatic indexing, which is not very convenient. Until now, indexes are only created by Dexter and never deleted later, this might also be a use case for optimizing a database. A nice feature would be, if the automatic indexing is done in a time where the database is not used a lot, for example at night. Also, support for partial indexes is not yet available.\\\\
The feature of excluding write-heavy table is handy for some cases, and also to set a minimum amount of query calls or total runtime avoid too much indexing makes the software much better.\\\\
Overall, we like the concept behind Dexter and think that there is much potential in this tool. Hopefully, we can expect more features in the future.
\section{Feedback and Presentation}
This paper was also presented in front of the  \href{https://www.swisspug.org/wiki/index.php/Swiss_PostgreSQL_Users_Group}{SwissPUG group} in the \href{https://www.hsr.ch/de/}{HSR} building on 20th of January, 2020 where we received a lot of feedback from some of the members from this group.\\
The Swiss PostgreSQL Users Group (SwissPUG) is a group of people sharing an interest in promoting the usage of the open-source database system PostgreSQL. \cite{SwissPUGWiki}\\
All of the members that were present in the presentation had never heard of Dexter before, and it was a pretty interesting and intriguing extension for them as well.\\
The Dexter extension was first presented theoretically only, describing what it is, how it works, and it's dependencies. After the presentation, Dexter was also demonstrated using a combination of Ubuntu, PostgreSQL, the Ruby programming language, HypoPG and Dexter itself. The "frozendata" database was used in conjunction with PostgreSQL to illustrate the extension. \\
\newline
In the demonstration, the main points that were discussed were:
\begin{enumerate}
\item Common Dexter commands
\item Methods that Dexter can use to analyze queries
\item The HypoPG extension
\item The pg\_query Ruby extension
\item The query parse and fingerprinting techniques
\item Capabilities of Dexter
\item Possible improvements of Dexter
\item etc
\end{enumerate}

After the presentation and the demonstration of this paper, many of the members were intrigued by the Dexter extensions and started making questions and discussing about the extension; Since Dexter uses other libraries and extensions (such as HypoPG and pg\_query), a lot of other discussions were created as a result of those dependencies too.\\
The attendees of the presentation were essentially interested in the techniques that Dexter uses in order to identify a right candidate for an index, how it suggests indexes and how those suggested indexes improve a given table query performance. They were also interested in the fingerprinting technique that Dexter uses with the help of the pg\_query extension, some of the multi-column indexes, how Dexter utilizes HypoPG etc.\\
\newline
Overall, it was a pretty good and beneficial presentation for the attendees, numerous of them provided excellent feedback on the presentation and the demonstration, they additionally left with a pretty good impression of the Dexter extension too.